{"openapi":"3.0.0","servers":[{"description":"SwaggerHub API Auto Mocking","url":"https://virtserver.swaggerhub.com/ZWEIMALL/a-metal-host-software/1.0.0"}],"info":{"description":"This describes the a-metal host software API","version":"1.0.0","title":"a-metal host software"},"paths":{"/allPrinterStored":{"get":{"summary":"gets list of stored printer","operationId":"listStoredPrinter","description":"By requesting you will get a list of all stored printers.\n","responses":{"200":{"description":"list of stored printers","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Printer"}}}}}}}},"/scanPrintersInNetwork":{"get":{"summary":"gets list of printers found in local network","operationId":"listNetworkPrinter","description":"By requesting you will get a list of all printers found in your \nlocal network.\n","responses":{"200":{"description":"list of printers available in local network","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Printer"}}}}}}}},"/printer":{"get":{"summary":"gets a stored printer by UUID and IP address","operationId":"getPrinter","description":"By passing in the appropriate options, you will get the assigned printer\n","parameters":[{"in":"query","name":"uuid","description":"UUID of the specific printer","schema":{"type":"string"}},{"in":"query","name":"ipAddress","description":"IP address of the specific printer","schema":{"type":"string"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Printer"}}}}},"400":{"description":"bad input parameter"},"404":{"description":"item not found"}}},"post":{"summary":"adds a printer to the list of stored printers","operationId":"addPrinterToStored","description":"By passing in the appropriate options, you can add a network printer \nto the list of stored printers.\n","responses":{"201":{"description":"printer added"},"400":{"description":"invalid input, object invalid"},"404":{"description":"item not found"},"409":{"description":"this printer already exists"}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Printer"}}},"description":"Printer item to add"}},"delete":{"summary":"removes a printer from the list of stored printers","operationId":"deletePrinterFromStored","description":"By passing in the appropriate options, you can remove a printer from the list of stored printers.\n","parameters":[{"in":"query","name":"uuid","description":"UUID of the specific printer","schema":{"type":"string"}},{"in":"query","name":"ipAddress","description":"IP address of the specific printer","schema":{"type":"string"}}],"responses":{"204":{"description":"printer deleted"},"400":{"description":"invalid input, object invalid"},"404":{"description":"item not found"}}}},"/preset":{"get":{"summary":"gets a printer preset by UUID, IP address and ID","operationId":"getPrinterPreset","description":"By passing in the appropriate options, you will get the assigned preset from the corresponding printer.\n","parameters":[{"in":"query","name":"uuid","description":"UUID of the specific printer","schema":{"type":"string"}},{"in":"query","name":"ipAddress","description":"IP address of the specific printer","schema":{"type":"string"}},{"in":"query","name":"id","description":"ID of the specific preset","schema":{"type":"integer","format":"int32"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PrinterPreset"}}}},"400":{"description":"bad input parameter"},"404":{"description":"item not found"}}},"post":{"summary":"creates a preset by UUID and IP of the corresponding printer","operationId":"addPrinterPreset","description":"By passing in the appropriate options, you can add a preset to the corresponding printer.\n","responses":{"201":{"description":"preset added"},"400":{"description":"invalid input, object invalid"},"404":{"description":"item not found"}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PrinterPreset"}}},"description":"Printer item to add"}},"delete":{"summary":"removes a printer from the list of stored printers","operationId":"deletePrinterPreset","description":"By passing in the appropriate options, you can remove a printer preset from the corresponding printer.\n","parameters":[{"in":"query","name":"uuid","description":"UUID of the corresponding printer","schema":{"type":"string","format":"uuid","example":"d290f1ee-6c54-4b01-90e6-d701748f0851"}},{"in":"query","name":"ipAddress","description":"IP address of the corresponding printer","schema":{"type":"string"}},{"in":"query","name":"id","description":"ID of the specific preset","schema":{"type":"integer","format":"int32"}}],"responses":{"204":{"description":"printer deleted"},"400":{"description":"invalid input, object invalid"},"404":{"description":"item not found"}}}},"/material":{"get":{"summary":"gets a material setting by UUID","operationId":"getMaterialSetting","description":"By passing in the appropriate options, you will get the assigned laser setting.\n","parameters":[{"in":"query","name":"uuid","description":"UUID of the specific laser setting","schema":{"type":"integer","format":"int32"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/MaterialSetting"}}}},"400":{"description":"bad input parameter"},"404":{"description":"item not found"}}},"post":{"summary":"creates a material setting","operationId":"addMaterialSetting","description":"By passing in the appropriate options, you can add a material setting.\n","responses":{"201":{"description":"material setting added"},"400":{"description":"invalid input, object invalid"},"404":{"description":"item not found"}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/MaterialSetting"}}},"description":"Material setting item to add"}},"put":{"summary":"updates a material setting","operationId":"updateMaterialSetting","description":"By passing in the appropriate options, you can update a material setting.\n","responses":{"204":{"description":"material setting updated"},"400":{"description":"invalid input, object invalid"},"404":{"description":"item not found"}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/MaterialSetting"}}},"description":"Material setting item to update"}},"delete":{"summary":"removes a material setting","operationId":"deleteMaterialSetting","description":"By passing in the appropriate options, you can remove a printer preset from the corresponding printer.\n","parameters":[{"in":"query","name":"id","description":"ID of the specific material setting","schema":{"type":"integer","format":"int32"}}],"responses":{"204":{"description":"material setting deleted"},"400":{"description":"invalid input, object invalid"},"404":{"description":"item not found"}}}},"/printerControls":{"get":{"summary":"gets current printer controls status","operationId":"getPrinterControlStatus","description":"You will get printer control status\n","responses":{"200":{"description":"printer control status","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PrinterControlStatus"}}}}}},"post":{"summary":"set printer controls","operationId":"setPrinterControl","description":"By passing in the appropriate options, you can set the printer control.\n","responses":{"201":{"description":"printer controls set","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PrinterControlStatus"}}}},"400":{"description":"invalid input, object invalid"}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PrinterControlRequest"}}},"description":"Printer control request to set printer controls"}}}},"components":{"schemas":{"MaterialSetting":{"type":"object","required":["uuid","name","printerSpeed","laserPower","overFeed","coatingSpeed"],"properties":{"uuid":{"type":"string","format":"uuid","example":"d290f1ee-6c54-4b01-90e6-d701748f0851"},"name":{"type":"string","example":"Laser Setting Fast Printing"},"printerSpeed":{"type":"integer","format":"int32","example":99},"laserPower":{"type":"integer","format":"int32","example":99},"overFeed":{"type":"integer","format":"int32","example":99},"coatingSpeed":{"type":"integer","format":"int32","example":99}}},"Printer":{"type":"object","required":["uuid","ipAddress","presetList"],"properties":{"uuid":{"type":"string","format":"uuid","example":"d290f1ee-6c54-4b01-90e6-d701748f0851"},"ipAddress":{"type":"string","example":"111.22.333.44"},"presetList":{"type":"array","items":{"$ref":"#/components/schemas/PrinterPreset"}}}},"PrinterPreset":{"type":"object","required":["id","name","xMax","xMin","yMax","yMin","zMax","zMin"],"properties":{"id":{"type":"integer","format":"int32","example":87},"name":{"type":"string","example":"Printer Preset Fast Printing"},"xMax":{"type":"integer","format":"int32","example":250},"xMin":{"type":"integer","format":"int32","example":0},"yMax":{"type":"integer","format":"int32","example":250},"yMin":{"type":"integer","format":"int32","example":0},"zMax":{"type":"integer","format":"int32","example":250},"zMin":{"type":"integer","format":"int32","example":0}}},"PrinterControlRequest":{"type":"object","required":["action","printer","printerPreset","materialSetting","gCodeUri"],"properties":{"action":{"type":"integer","format":"int32","example":1},"printer":{"$ref":"#/components/schemas/Printer"},"printerPreset":{"$ref":"#/components/schemas/PrinterPreset"},"materialSetting":{"$ref":"#/components/schemas/MaterialSetting"},"gCodeUri":{"type":"string","example":"C:\\a-metal\\g-code\\test.gcode"}}},"PrinterControlStatus":{"type":"object","required":["action","statusText"],"properties":{"action":{"type":"integer","format":"int32","example":1},"statusText":{"type":"string","example":"Printer 47 is printing"}}}}}}